import { _decorator, Component, Node, Camera, EventTouch, Intersection2D, PolygonCollider2D, UITransform, Vec2 } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('testNode')
export class testNode extends Component {
    @property({type: Node})
    TouchNode : Node = null;
    @property( {type : Camera} )
    CameraNode : Camera = null;
    start() {

        this.node.on(Node.EventType.TOUCH_END, (event: EventTouch) => {
            event.preventSwallow = true;
            
            let Point = event.getLocation();
            console.log('Point-->', Point);
            
            let point = this.CameraNode.screenPointToRay(Point.x, Point.y);
            console.log("point-->", point);
            
            let nodepos = this.node.getComponent(UITransform).convertToNodeSpaceAR(point.o);
            Point = new Vec2(nodepos.x, nodepos.y);
            let nodePoints = this.TouchNode.getComponent(PolygonCollider2D).points;
            if (Intersection2D.pointInPolygon(Point, nodePoints)) {
                console.log("点在多边形内-->");
            }
            else {

            }

        }, this);
    }

    update(deltaTime: number) {
        
    }
}

